require 'bdd'

def queen_bdd(n)
  BDD.set_var_num(n*n)
  res = BDD.true

  0.upto(n-1) { |i|
    row = BDD.false

    0.upto(n-1) { |j|
      xij = BDD.get_var(i*n+j)
      row.or!(xij)

      c = BDD.true
      0.upto(n-1) { |l|
        c.and!(BDD.get_var(i*n+l).not) if l != j
      }
      res.and!(xij.imply(c))

      c = BDD.true
      0.upto(n-1) { |k|
        c.and!(BDD.get_var(k*n+j).not) if k != i
      }
      res.and!(xij.imply(c))
      
      c = BDD.true
      0.upto(n-1) { |k|
        c.and!(BDD.get_var(k*n+j+k-i).not) if k != i && j+k-i < n && j+k-i >= 0
      }
      res.and!(xij.imply(c))

      c = BDD.true
      0.upto(n-1) { |k|
        c.and!(BDD.get_var(k*n+j+i-k).not) if k != i && j+i-k < n && j+i-k >= 0
      }
      res.and!(xij.imply(c))
    }
    res.and!(row)
  }
  res
end

def queen_show(n,s)
  a = Array.new(n)
  i = 0
  s.each { |b|
    a[i/n] = (i%n)+1 if b
    i += 1
  }
  puts "One solution: " + a.inspect
end

(1..9).each { |n|
  b = queen_bdd(n)
  c = b.sat_count
  puts "#{n} queens problem has #{c} solutions. BDD has #{b.node_count} nodes."
  b.sat_one.each { |s| queen_show(n,s) } if c > 0
}


