require 'bdd'

BDD.show_gc(true)

# Construct a BDD representing a n-xor between n variables =
# a1 & not a2 & not a3 & ... & not aN
# |
# a2 & not a1 & not a3 & ... & not aN
# | ...
def nxor2(*vars)
  disj=BDD.false
  conj=nil       # optimization to ask Ruby to create 'conj'.
  vars.flatten!
  vars.collect { |vi|
    conj=BDD.true
    vars.each { |vj| conj.and!(vi == vj ? vi : vj.not) }
    conj
  }.each { |f| disj.or!(f) }
  disj
end

BDD.set_var_num(200)
puts "Fast generation..."
a=BDD.nxor((0..199).collect{|i|BDD.get_var(i)})
puts "Slow generation..."
b=nxor2((0..199).collect{|i|BDD.get_var(i)})
puts "Check: " + (a == b ? "OK" : "Not OK")
