/* -*- mode: C; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
 *
 * This file is part of the Ruby binding of Buddy.
 *
 * This Ruby binding is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This binding is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this binding; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA  02110-1301  USA.
 *
 * Author: Alexandre David.
 * Date: 2006-04-05.
 */

#include <set>

static std::set<int> visited;

// I don't want to re-implement set<int> so I wrapp it in C.

extern "C" {
  int  visited_has(int x)    { return visited.find(x) != visited.end(); }
  void visited_clear()       { visited.clear(); }
  void visited_insert(int x) { visited.insert(x); }
}
